package ru.dbotthepony.kstarbound.util

class Timer(val period: Double, val executionTimes: Int, val func: (Timer) -> Unit) {
	private var counter = 0.0
	var cycles = 0
		private set
	var destroyed: Boolean = false
		private set

	fun think(delta: Double) {
		if (destroyed) {
			throw IllegalStateException("This timer is destroyed")
		}

		counter += delta

		if (counter >= period) {
			counter -= period
			func.invoke(this)
			cycles++
		}

		if (!destroyed && executionTimes > 0 && cycles >= executionTimes) {
			destroy()
		}
	}

	fun destroy() {
		if (destroyed) {
			throw IllegalStateException("Already destroyed")
		}

		destroyed = true
	}
}